<?php
if (!defined('DC_RC_PATH')) { return; }

require __DIR__.'/_widget.php';

dcCore::app()->tpl->addValue('RandomRedirURL', array('tplRandomPost', 'tplRandomRedirURL'));
dcCore::app()->tpl->addValue('RandomStaticURL', array('tplRandomPost', 'tplRandomStaticURL'));

dcCore::app()->tpl->addBlock('RandomPost', array('tplRandomPost', 'tplRandomPostBlock'));
dcCore::app()->tpl->addValue('RandomPostURL', array('tplRandomPost', 'tplRandomPostURL'));
dcCore::app()->tpl->addValue('RandomPostTitle', array('tplRandomPost', 'tplRandomPostTitle'));
dcCore::app()->tpl->addValue('RandomPostExcerpt', array('tplRandomPost', 'tplRandomPostExcerpt'));

class urlRandomPost extends dcUrlHandlers
{
    public static function redirRandomPost($args)
    {
        $args = trim($args, '/');
        if ($args == '') {
            $args = randomPost::allCatID;
        }
        $randomPost = new randomPost(dcCore::app()->blog, false, $args);

        // Get the URL of the post, and redirect to it
        http::head(302, 'Found');
        header('Location: '.$randomPost->getURL());
        exit;
    }

    public static function staticRandomPost($args)
    {
        $args = trim($args, '/');
        if ($args == '') {
            $args = randomPost::allCatID;
        }
        $randomPost = new randomPost(dcCore::app()->blog, false, $args);

        // Get the URL of the post and all associated info
        $params['post_url'] = $randomPost->getPostURL();
        dcCore::app()->ctx->posts = dcCore::app()->blog->getPosts($params);
        if (dcCore::app()->ctx->posts->isEmpty()) {
            # No entry
            self::p404();
        }

        // Prevent the display of the comments form
        dcCore::app()->blog->settings->system->allow_comments = false;

        // Display the post
        self::serveDocument('post.html', 'text/html', false, false);
    }
}

class tplRandomPost
{
    public static function tplRandomPostBlock($attr, $content)
    {
        $categoryID = isset($attr['limit_to_category_id']) ? $attr['limit_to_category_id'] : randomPost::allCatID;
        return '<?php dcCore::app()->ctx->randomPost = new randomPost(dcCore::app()->blog,true,"'.$categoryID.'"); ?>'.
            $content.
            '<?php unset(dcCore::app()->ctx->randomPost); ?>';
    }

    public static function tplRandomPostTitle($attr)
    {
        return '<?php echo context::global_filter(dcCore::app()->ctx->randomPost->getPostTitle(), 1, 1, 0, 0, 0); ?>';
    }

    public static function tplRandomPostURL($attr)
    {
        return '<?php echo dcCore::app()->ctx->randomPost->getPostURL(); ?>';
    }

    public static function tplRandomPostExcerpt($attr)
    {
        $maxLength = isset($attr['max_length']) ? $attr['max_length'] : 200;
        return '<?php if (dcCore::app()->ctx->randomPost->getPost()->isExtended()) {'.
            ' $excerpt = dcCore::app()->ctx->randomPost->getPost()->getExcerpt();'.
            ' } else {'.
            ' $excerpt = dcCore::app()->ctx->randomPost->getPost()->getContent();'.
            ' }'.
            ' if ('.$maxLength.' > 0 && strlen($excerpt) > '.$maxLength.') {'.
            ' $excerpt = substr($excerpt, 0, '.$maxLength.');'.
            ' $excerpt = substr($excerpt, 0, strrpos($excerpt, " "))." ...";'.
            ' }'.
            ' echo $excerpt; ?>';
    }

    public static function tplRandomRedirURL($attr)
    {
        $categoryID = isset($attr['limit_to_category_id']) ? '/'.$attr['limit_to_category_id'] : '';
        $f = dcCore::app()->tpl->getFilters($attr);
        return '<?php echo '.sprintf($f, 'dcCore::app()->blog->url.dcCore::app()->url->getBase("randomPost")."'.$categoryID.'"').'; ?>';
    }

    public static function tplRandomStaticURL($attr)
    {
        $categoryID = isset($attr['limit_to_category_id']) ? '/'.$attr['limit_to_category_id'] : '';
        $f = dcCore::app()->tpl->getFilters($attr);
        return '<?php echo '.sprintf($f, 'dcCore::app()->blog->url.dcCore::app()->url->getBase("randomStaticPost")."'.$categoryID.'"').'; ?>';
    }

    public static function randomPostWidget(dcWidget $w)
    {
        if ($w->homeonly && dcCore::app()->url->type != 'default') {
            return '';
        }

        $title = $w->title ? html::escapeHTML($w->title) : __('Random post');
        $res = '<div class="randompost">';
        if ($w->redirect) {
            $res .= '<ul><li><a href="'.dcCore::app()->blog->url.dcCore::app()->url->getBase('').'random';
            if ($w->category != randomPost::allCatID) {
                $res .= '/'.$w->category;
            }
            $res .= '">'.$title.'</a></li></ul>';
        } else {
            $randomPost = new randomPost(dcCore::app()->blog, $w->excerpt, $w->category);
            $res .= '<h2>'.$title.'</h2>' .
                '<p class="randomPostTitle">';
            $res .= '<a href="'.$randomPost->getURL().'">'.
                html::escapeHTML($randomPost->getPostTitle()).'</a>';
            $res .= '</p>';
            if ($w->excerpt) {
                if ($randomPost->getPost()->isExtended()) {
                    $excerpt = $randomPost->getPost()->getExcerpt();
                } else {
                    $excerpt = $randomPost->getPost()->getContent();
                }
                $excerpt = strip_tags($excerpt, $w->allowed_tags);
                $excerpt = preg_replace('/\s+/', ' ', $excerpt);
                if ($w->max_length > 0 && strlen($excerpt) > $w->max_length) {
                    $excerpt = substr($excerpt, 0, $w->max_length);
                    $excerpt = substr($excerpt, 0, strrpos($excerpt, ' ')).' ...';
                }
                $res .= '<p>'.$excerpt.'</p>';
            }
        }
        $res .= '</div>';

        return $res;
    }
}
